/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2020/04/30
* Description        : Main program body.
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* SPDX-License-Identifier: Apache-2.0
*******************************************************************************/
#include "ch32v30x.h"
#include <rtthread.h>
#include <rthw.h>
#include "drivers/pin.h"
#include "net_app.h"
#include "usbdisk_app.h"
#include "rtc_app.h"
#include "board.h"

/* Global typedef */

/* Global define */

/* LED0ͨrtpinӿ  */
#define LED0_PIN  18   //PC3

/* Global Variable */





/*********************************************************************
 * @fn      main
 *
 * @brief   mainֻһ֮߳һ,mainû̳߳ʼֱӷأδפ
 *
 * @note    tshellnetidleUSB
 *          㲥DNSMQTT_PUBȻȡֱӴshellб
 *
 *          netDHCPɹʹDHCPIPгʼʹĬIPnet½
 *                                  һTCPһUDPһMQTTһDHCPһDNSDHCPڽ
 *                                 ɹʱͷsocketDNSΪһֱȡδͷţռһUDP socket
 *          MQTTӺtopic/1,pubsubͬpubͬʱյݡ
 *
 * @return  none
 */
int main(void)
{
    rt_kprintf("\r\n MCU: CH32V307\r\n");
    rt_kprintf(" SysClk: %dHz\r\n",SystemCoreClock);
    rt_kprintf(" www.wch.cn\r\n");
    net_task_init();
    usb_task_init();
    rtc_task_init();
	return 0;

//    rt_kprintf("main will return\r\n");
//    while(1)
//    {
//        rt_thread_mdelay(1000);
//    }
}

/*********************************************************************
 * @fn      led
 *
 * @brief   ʹӿڲI/O
 *
 * @return  none
 */
int led(void)
{
    rt_uint8_t count;

    rt_pin_mode(LED0_PIN, PIN_MODE_OUTPUT);
    rt_kprintf("led_SP:%08x\r\n",__get_SP());
    for(count = 0 ; count < 10 ;count++)
    {
        rt_pin_write(LED0_PIN, PIN_LOW);
        rt_kprintf("led on, count : %d\r\n", count);
        rt_thread_mdelay(500);


        rt_pin_write(LED0_PIN, PIN_HIGH);
        rt_kprintf("led off\r\n");
        rt_thread_mdelay(500);

    }
    return 0;
}

MSH_CMD_EXPORT(led,  led sample by using I/O drivers);



